import Vue from 'vue'
import Router from 'vue-router'
import routes from '../config/routes'

// 注册路由
Vue.use(Router)

// 防止连续点击多次路由报错
let routerPush = Router.prototype.push;
Router.prototype.push = function push(location) {
    return routerPush.call(this, location).catch(err => err)
}
let originalReplace = Router.prototype.replace
Router.prototype.replace = function push(location, onResolve, onReject) {
    if (onResolve || onReject) return originalReplace.call(this, location, onResolve, onReject)
    return originalReplace.call(this, location).catch((err) => err)
}

export default new Router({
    routes: [{
        path: '/404', name: '404', component: (resolve) => require(['@/views/404/index'], resolve),
    }, ...routes]
})